t / test-lib.shon commit Merge branch 'maint-1.6.0' into maint (9b27ea9)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5
   6# Keep the original TERM for say_color
   7ORIGINAL_TERM=$TERM
   8
   9# For repeatability, reset the environment to known value.
  10LANG=C
  11LC_ALL=C
  12PAGER=cat
  13TZ=UTC
  14TERM=dumb
  15export LANG LC_ALL PAGER TERM TZ
  16EDITOR=:
  17VISUAL=:
  18unset GIT_EDITOR
  19unset AUTHOR_DATE
  20unset AUTHOR_EMAIL
  21unset AUTHOR_NAME
  22unset COMMIT_AUTHOR_EMAIL
  23unset COMMIT_AUTHOR_NAME
  24unset EMAIL
  25unset GIT_ALTERNATE_OBJECT_DIRECTORIES
  26unset GIT_AUTHOR_DATE
  27GIT_AUTHOR_EMAIL=author@example.com
  28GIT_AUTHOR_NAME='A U Thor'
  29unset GIT_COMMITTER_DATE
  30GIT_COMMITTER_EMAIL=committer@example.com
  31GIT_COMMITTER_NAME='C O Mitter'
  32unset GIT_DIFF_OPTS
  33unset GIT_DIR
  34unset GIT_WORK_TREE
  35unset GIT_EXTERNAL_DIFF
  36unset GIT_INDEX_FILE
  37unset GIT_OBJECT_DIRECTORY
  38unset GIT_CEILING_DIRECTORIES
  39unset SHA1_FILE_DIRECTORIES
  40unset SHA1_FILE_DIRECTORY
  41GIT_MERGE_VERBOSITY=5
  42export GIT_MERGE_VERBOSITY
  43export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  44export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  45export EDITOR VISUAL
  46GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
  47
  48# Protect ourselves from common misconfiguration to export
  49# CDPATH into the environment
  50unset CDPATH
  51
  52case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  53        1|2|true)
  54                echo "* warning: Some tests will not work if GIT_TRACE" \
  55                        "is set as to trace on STDERR ! *"
  56                echo "* warning: Please set GIT_TRACE to something" \
  57                        "other than 1, 2 or true ! *"
  58                ;;
  59esac
  60
  61# Each test should start with something like this, after copyright notices:
  62#
  63# test_description='Description of this test...
  64# This test checks if command xyzzy does the right thing...
  65# '
  66# . ./test-lib.sh
  67[ "x$ORIGINAL_TERM" != "xdumb" ] && (
  68                TERM=$ORIGINAL_TERM &&
  69                export TERM &&
  70                [ -t 1 ] &&
  71                tput bold >/dev/null 2>&1 &&
  72                tput setaf 1 >/dev/null 2>&1 &&
  73                tput sgr0 >/dev/null 2>&1
  74        ) &&
  75        color=t
  76
  77while test "$#" -ne 0
  78do
  79        case "$1" in
  80        -d|--d|--de|--deb|--debu|--debug)
  81                debug=t; shift ;;
  82        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
  83                immediate=t; shift ;;
  84        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
  85                export GIT_TEST_LONG=t; shift ;;
  86        -h|--h|--he|--hel|--help)
  87                help=t; shift ;;
  88        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
  89                verbose=t; shift ;;
  90        -q|--q|--qu|--qui|--quie|--quiet)
  91                quiet=t; shift ;;
  92        --no-color)
  93                color=; shift ;;
  94        --no-python)
  95                # noop now...
  96                shift ;;
  97        *)
  98                break ;;
  99        esac
 100done
 101
 102if test -n "$color"; then
 103        say_color () {
 104                (
 105                TERM=$ORIGINAL_TERM
 106                export TERM
 107                case "$1" in
 108                        error) tput bold; tput setaf 1;; # bold red
 109                        skip)  tput bold; tput setaf 2;; # bold green
 110                        pass)  tput setaf 2;;            # green
 111                        info)  tput setaf 3;;            # brown
 112                        *) test -n "$quiet" && return;;
 113                esac
 114                shift
 115                printf "* %s" "$*"
 116                tput sgr0
 117                echo
 118                )
 119        }
 120else
 121        say_color() {
 122                test -z "$1" && test -n "$quiet" && return
 123                shift
 124                echo "* $*"
 125        }
 126fi
 127
 128error () {
 129        say_color error "error: $*"
 130        trap - exit
 131        exit 1
 132}
 133
 134say () {
 135        say_color info "$*"
 136}
 137
 138test "${test_description}" != "" ||
 139error "Test script did not set test_description."
 140
 141if test "$help" = "t"
 142then
 143        echo "$test_description"
 144        exit 0
 145fi
 146
 147exec 5>&1
 148if test "$verbose" = "t"
 149then
 150        exec 4>&2 3>&1
 151else
 152        exec 4>/dev/null 3>/dev/null
 153fi
 154
 155test_failure=0
 156test_count=0
 157test_fixed=0
 158test_broken=0
 159test_success=0
 160
 161die () {
 162        echo >&5 "FATAL: Unexpected exit with code $?"
 163        exit 1
 164}
 165
 166trap 'die' exit
 167
 168# The semantics of the editor variables are that of invoking
 169# sh -c "$EDITOR \"$@\"" files ...
 170#
 171# If our trash directory contains shell metacharacters, they will be
 172# interpreted if we just set $EDITOR directly, so do a little dance with
 173# environment variables to work around this.
 174#
 175# In particular, quoting isn't enough, as the path may contain the same quote
 176# that we're using.
 177test_set_editor () {
 178        FAKE_EDITOR="$1"
 179        export FAKE_EDITOR
 180        VISUAL='"$FAKE_EDITOR"'
 181        export VISUAL
 182}
 183
 184test_tick () {
 185        if test -z "${test_tick+set}"
 186        then
 187                test_tick=1112911993
 188        else
 189                test_tick=$(($test_tick + 60))
 190        fi
 191        GIT_COMMITTER_DATE="$test_tick -0700"
 192        GIT_AUTHOR_DATE="$test_tick -0700"
 193        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 194}
 195
 196# You are not expected to call test_ok_ and test_failure_ directly, use
 197# the text_expect_* functions instead.
 198
 199test_ok_ () {
 200        test_count=$(expr "$test_count" + 1)
 201        test_success=$(expr "$test_success" + 1)
 202        say_color "" "  ok $test_count: $@"
 203}
 204
 205test_failure_ () {
 206        test_count=$(expr "$test_count" + 1)
 207        test_failure=$(expr "$test_failure" + 1);
 208        say_color error "FAIL $test_count: $1"
 209        shift
 210        echo "$@" | sed -e 's/^/        /'
 211        test "$immediate" = "" || { trap - exit; exit 1; }
 212}
 213
 214test_known_broken_ok_ () {
 215        test_count=$(expr "$test_count" + 1)
 216        test_fixed=$(($test_fixed+1))
 217        say_color "" "  FIXED $test_count: $@"
 218}
 219
 220test_known_broken_failure_ () {
 221        test_count=$(expr "$test_count" + 1)
 222        test_broken=$(($test_broken+1))
 223        say_color skip "  still broken $test_count: $@"
 224}
 225
 226test_debug () {
 227        test "$debug" = "" || eval "$1"
 228}
 229
 230test_run_ () {
 231        eval >&3 2>&4 "$1"
 232        eval_ret="$?"
 233        return 0
 234}
 235
 236test_skip () {
 237        this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
 238        this_test="$this_test.$(expr "$test_count" + 1)"
 239        to_skip=
 240        for skp in $GIT_SKIP_TESTS
 241        do
 242                case "$this_test" in
 243                $skp)
 244                        to_skip=t
 245                esac
 246        done
 247        case "$to_skip" in
 248        t)
 249                say_color skip >&3 "skipping test: $@"
 250                test_count=$(expr "$test_count" + 1)
 251                say_color skip "skip $test_count: $1"
 252                : true
 253                ;;
 254        *)
 255                false
 256                ;;
 257        esac
 258}
 259
 260test_expect_failure () {
 261        test "$#" = 2 ||
 262        error "bug in the test script: not 2 parameters to test-expect-failure"
 263        if ! test_skip "$@"
 264        then
 265                say >&3 "checking known breakage: $2"
 266                test_run_ "$2"
 267                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 268                then
 269                        test_known_broken_ok_ "$1"
 270                else
 271                    test_known_broken_failure_ "$1"
 272                fi
 273        fi
 274        echo >&3 ""
 275}
 276
 277test_expect_success () {
 278        test "$#" = 2 ||
 279        error "bug in the test script: not 2 parameters to test-expect-success"
 280        if ! test_skip "$@"
 281        then
 282                say >&3 "expecting success: $2"
 283                test_run_ "$2"
 284                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 285                then
 286                        test_ok_ "$1"
 287                else
 288                        test_failure_ "$@"
 289                fi
 290        fi
 291        echo >&3 ""
 292}
 293
 294test_expect_code () {
 295        test "$#" = 3 ||
 296        error "bug in the test script: not 3 parameters to test-expect-code"
 297        if ! test_skip "$@"
 298        then
 299                say >&3 "expecting exit code $1: $3"
 300                test_run_ "$3"
 301                if [ "$?" = 0 -a "$eval_ret" = "$1" ]
 302                then
 303                        test_ok_ "$2"
 304                else
 305                        test_failure_ "$@"
 306                fi
 307        fi
 308        echo >&3 ""
 309}
 310
 311# test_external runs external test scripts that provide continuous
 312# test output about their progress, and succeeds/fails on
 313# zero/non-zero exit code.  It outputs the test output on stdout even
 314# in non-verbose mode, and announces the external script with "* run
 315# <n>: ..." before running it.  When providing relative paths, keep in
 316# mind that all scripts run in "trash directory".
 317# Usage: test_external description command arguments...
 318# Example: test_external 'Perl API' perl ../path/to/test.pl
 319test_external () {
 320        test "$#" -eq 3 ||
 321        error >&5 "bug in the test script: not 3 parameters to test_external"
 322        descr="$1"
 323        shift
 324        if ! test_skip "$descr" "$@"
 325        then
 326                # Announce the script to reduce confusion about the
 327                # test output that follows.
 328                say_color "" " run $(expr "$test_count" + 1): $descr ($*)"
 329                # Run command; redirect its stderr to &4 as in
 330                # test_run_, but keep its stdout on our stdout even in
 331                # non-verbose mode.
 332                "$@" 2>&4
 333                if [ "$?" = 0 ]
 334                then
 335                        test_ok_ "$descr"
 336                else
 337                        test_failure_ "$descr" "$@"
 338                fi
 339        fi
 340}
 341
 342# Like test_external, but in addition tests that the command generated
 343# no output on stderr.
 344test_external_without_stderr () {
 345        # The temporary file has no (and must have no) security
 346        # implications.
 347        tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
 348        stderr="$tmp/git-external-stderr.$$.tmp"
 349        test_external "$@" 4> "$stderr"
 350        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 351        descr="no stderr: $1"
 352        shift
 353        say >&3 "expecting no stderr from previous command"
 354        if [ ! -s "$stderr" ]; then
 355                rm "$stderr"
 356                test_ok_ "$descr"
 357        else
 358                if [ "$verbose" = t ]; then
 359                        output=`echo; echo Stderr is:; cat "$stderr"`
 360                else
 361                        output=
 362                fi
 363                # rm first in case test_failure exits.
 364                rm "$stderr"
 365                test_failure_ "$descr" "$@" "$output"
 366        fi
 367}
 368
 369# This is not among top-level (test_expect_success | test_expect_failure)
 370# but is a prefix that can be used in the test script, like:
 371#
 372#       test_expect_success 'complain and die' '
 373#           do something &&
 374#           do something else &&
 375#           test_must_fail git checkout ../outerspace
 376#       '
 377#
 378# Writing this as "! git checkout ../outerspace" is wrong, because
 379# the failure could be due to a segv.  We want a controlled failure.
 380
 381test_must_fail () {
 382        "$@"
 383        test $? -gt 0 -a $? -le 129 -o $? -gt 192
 384}
 385
 386# test_cmp is a helper function to compare actual and expected output.
 387# You can use it like:
 388#
 389#       test_expect_success 'foo works' '
 390#               echo expected >expected &&
 391#               foo >actual &&
 392#               test_cmp expected actual
 393#       '
 394#
 395# This could be written as either "cmp" or "diff -u", but:
 396# - cmp's output is not nearly as easy to read as diff -u
 397# - not all diff versions understand "-u"
 398
 399test_cmp() {
 400        $GIT_TEST_CMP "$@"
 401}
 402
 403# Most tests can use the created repository, but some may need to create more.
 404# Usage: test_create_repo <directory>
 405test_create_repo () {
 406        test "$#" = 1 ||
 407        error "bug in the test script: not 1 parameter to test-create-repo"
 408        owd=`pwd`
 409        repo="$1"
 410        mkdir -p "$repo"
 411        cd "$repo" || error "Cannot setup test environment"
 412        "$GIT_EXEC_PATH/git" init "--template=$GIT_EXEC_PATH/templates/blt/" >&3 2>&4 ||
 413        error "cannot run git init -- have you built things yet?"
 414        mv .git/hooks .git/hooks-disabled
 415        cd "$owd"
 416}
 417
 418test_done () {
 419        trap - exit
 420        test_results_dir="$TEST_DIRECTORY/test-results"
 421        mkdir -p "$test_results_dir"
 422        test_results_path="$test_results_dir/${0%-*}-$$"
 423
 424        echo "total $test_count" >> $test_results_path
 425        echo "success $test_success" >> $test_results_path
 426        echo "fixed $test_fixed" >> $test_results_path
 427        echo "broken $test_broken" >> $test_results_path
 428        echo "failed $test_failure" >> $test_results_path
 429        echo "" >> $test_results_path
 430
 431        if test "$test_fixed" != 0
 432        then
 433                say_color pass "fixed $test_fixed known breakage(s)"
 434        fi
 435        if test "$test_broken" != 0
 436        then
 437                say_color error "still have $test_broken known breakage(s)"
 438                msg="remaining $(($test_count-$test_broken)) test(s)"
 439        else
 440                msg="$test_count test(s)"
 441        fi
 442        case "$test_failure" in
 443        0)
 444                # We could:
 445                # cd .. && rm -fr 'trash directory'
 446                # but that means we forbid any tests that use their own
 447                # subdirectory from calling test_done without coming back
 448                # to where they started from.
 449                # The Makefile provided will clean this test area so
 450                # we will leave things as they are.
 451
 452                say_color pass "passed all $msg"
 453
 454                test -d "$remove_trash" &&
 455                cd "$(dirname "$remove_trash")" &&
 456                rm -rf "$(basename "$remove_trash")"
 457
 458                exit 0 ;;
 459
 460        *)
 461                say_color error "failed $test_failure among $msg"
 462                exit 1 ;;
 463
 464        esac
 465}
 466
 467# Test the binaries we have just built.  The tests are kept in
 468# t/ subdirectory and are run in 'trash directory' subdirectory.
 469TEST_DIRECTORY=$(pwd)
 470PATH=$TEST_DIRECTORY/..:$PATH
 471GIT_EXEC_PATH=$(pwd)/..
 472GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
 473unset GIT_CONFIG
 474GIT_CONFIG_NOSYSTEM=1
 475GIT_CONFIG_NOGLOBAL=1
 476export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
 477
 478GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
 479export GITPERLLIB
 480test -d ../templates/blt || {
 481        error "You haven't built things yet, have you?"
 482}
 483
 484if ! test -x ../test-chmtime; then
 485        echo >&2 'You need to build test-chmtime:'
 486        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 487        exit 1
 488fi
 489
 490. ../GIT-BUILD-OPTIONS
 491
 492# Test repository
 493test="trash directory.$(basename "$0" .sh)"
 494test ! -z "$debug" || remove_trash="$TEST_DIRECTORY/$test"
 495rm -fr "$test" || {
 496        trap - exit
 497        echo >&5 "FATAL: Cannot prepare test area"
 498        exit 1
 499}
 500
 501test_create_repo "$test"
 502# Use -P to resolve symlinks in our working directory so that the cwd
 503# in subprocesses like git equals our $PWD (for pathname comparisons).
 504cd -P "$test" || exit 1
 505
 506this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
 507for skp in $GIT_SKIP_TESTS
 508do
 509        to_skip=
 510        for skp in $GIT_SKIP_TESTS
 511        do
 512                case "$this_test" in
 513                $skp)
 514                        to_skip=t
 515                esac
 516        done
 517        case "$to_skip" in
 518        t)
 519                say_color skip >&3 "skipping test $this_test altogether"
 520                say_color skip "skip all tests in $this_test"
 521                test_done
 522        esac
 523done